package org.eclipse.hyades.perfmon.xml;

import junit.framework.*;

public class FastStringBufferTest extends TestCase {
	
	public void testLength() {
			String sampleString;
			sampleString = new String("hello world");
			FastStringBuffer FSB = new FastStringBuffer(sampleString);
//check length
			Assert.assertEquals(FSB.length(),sampleString.length());

	}
	
	public void testAppendString(){
		String sampleString, sampleString1;
		sampleString = new String("hello world");
		sampleString1 = new String(" test");
		FastStringBuffer FSB = new FastStringBuffer(sampleString);
//check length
		Assert.assertEquals(FSB.length(),sampleString.length());
		
		FSB.append(sampleString1);
//check length			
		Assert.assertEquals(FSB.length(),sampleString.length()+ sampleString1.length());
	}
	
	public void testDelete(){
		String delString;
		delString = new String("Testing Delete");
		
		FastStringBuffer FSB = new FastStringBuffer(delString);

//delete last half of string
		FSB.delete(7,14);
//check length
		Assert.assertEquals(FSB.length(),7);
	}
	
	public void testDeleteCharAt(){
		String delCharString, expectedString;
		delCharString = new String("Testing Del Char At");
		expectedString = new String("Testing DelChar At");
		
		FastStringBuffer FSB = new FastStringBuffer(delCharString);
		
//delete space between Del and Char
		FSB.deleteCharAt(11);
		
//compare strings
		Assert.assertEquals(FSB.toString(),expectedString);
	}
	
	public void testReplace(){
		String replaceString, expectedString;
		replaceString = new String("Testing Replace String");
		expectedString = new String("Tested Replace String");
		
		FastStringBuffer FSB = new FastStringBuffer(replaceString);
		
		FSB.replace(4,7,"ed");
		
//		compare strings
		Assert.assertEquals(FSB.toString(),expectedString);
	}
	
	public void testInsertString(){
		String originalString, insertString, expectedString;
		originalString = new String("Testing String");
		insertString = new String("insert ");
		expectedString = new String("Testing insert String");
		
		FastStringBuffer FSB = new FastStringBuffer(originalString);
		
		FSB.insert(8,insertString);
		
		Assert.assertEquals(FSB.toString(),expectedString);
	}
	
	public void testIndexOfChar(){
		String indexString;
		indexString = new String("Testing Indexing");
		
		FastStringBuffer FSB = new FastStringBuffer(indexString);
		
		Assert.assertEquals(FSB.indexOf("g",0),6);	
	}
	
	public void testIndexString(){
		String indexString, iString;
		indexString = new String("Testing Indexing");
		iString = new String("Ind");
		
		FastStringBuffer FSB = new FastStringBuffer(indexString);
		
		Assert.assertEquals(FSB.indexOf(iString),8);
	}
}