package org.eclipse.hyades;

import junit.framework.*;
import java.util.*;

/**
 * TestSuite that runs all the sample tests
 */
public class AllTests {

	public static void addPlugins(ArrayList plugins) {
		//
		// Add hyades plugins here
		//
		plugins.add("org.eclipse.hyades.perfmon");
		plugins.add("org.eclipse.hyades.statistical.ui");
		plugins.add("org.eclipse.hyades.trace.ui");
	}
	
	public static void main (String[] args) {
		junit.swingui.TestRunner.main(new String[]{"org.eclipse.hyades.AllTests"});
//		junit.textui.TestRunner.run (suite());
	}
	
	public static Test suite() {
		TestSuite testsuite = new TestSuite();
		
		ArrayList plugins = new ArrayList();

		//get a list of hyades plugins with tests
		addPlugins(plugins);
		
		//create a testsuite of the tests
		for (int i = 0; i < plugins.size(); i++) {
			addTests(testsuite,(String)plugins.get(i));
		}
		
	    return testsuite;
	}
	
	public static void addTests(TestSuite testsuite, String plugin) {
		boolean hasTests = false;
		TestSuite tsuite = null;
		try {
			Class c = Class.forName(plugin+".AllTests");
			tsuite = (TestSuite)c.newInstance();
			hasTests = true;
		} catch (Exception e) {
		}

		//add a test which check to see if this plugin has JUnit tests
		HasTests hastests = new HasTests(plugin,hasTests);
		testsuite.addTest(hastests);
		
		if (tsuite != null) {
			//If this plugin has tests, add them
			testsuite.addTest(tsuite);
		}
	}

}